﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;

	public class Liaer extends Sprite
	{
		private var background:Bitmap;
		private var bmd:BitmapData;
		private var colors:Array = [Math.random()*0xffffff,Math.random()*0x00ff00,Math.random()*0xff00ff,Math.random()*0x00ffff];
		private var canevas:Sprite = new Sprite();
		private var circles:Array;
		public function Liaer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			setup();
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setup();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function setup():void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			background = new Bitmap(bmd);
			background.smoothing = true;
			addChild(background);
			buildModels(100);
		}
		private function buildModels(val:uint):void
		{
			circles = [];
			for(var i:uint = 0;i<val;i++){
				circles.push({'r':(Math.random()*400+10),'centerX':(Math.random()*stage.stageWidth),'centerY':(Math.random()*stage.stageHeight),'angle':Math.random()*360,'color':colors[Math.round(Math.random()*(colors.length-1))],'dec':Math.random()*360});
			}
		}
		private function enterHandler(e:Event):void
		{
			for(var j:uint = 0;j<circles.length;j++){
				canevas.graphics.clear();
				for(var i:uint = 0;i<30;i++){
					circles[j].r+=0.001;
					canevas.graphics.lineStyle(Math.random()*1,circles[j].color,i/100);
					(i==0)?canevas.graphics.moveTo(Math.tan((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerY):canevas.graphics.lineTo(Math.cos((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/180)*circles[j].r+ circles[j].centerY);
				}
				bmd.draw(canevas);
				circles[j].centerX+=Math.cos(circles[j].angle*Math.PI*360)*2;
				circles[j].centerY+=Math.cos(circles[j].angle*Math.PI*180)*2;
				circles[j].dec+=Math.sin(circles[j].angle*Math.random()*360);
			}
		}
	}
}